extends KinematicBody2D

export var WALK_SPEED = 200
export var TURN_SPEED = 1
export (Array, NodePath) var MOVEMENT_STRATEGIES
export var player_node : NodePath
var player 


var movement_strategies = []

var direction = Vector2.UP
var speed = 0
var target_direction = direction

onready var sprite = get_node("Sprite")


# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	player_node = NodePath("../Player")
	player = get_node(player_node) as KinematicBody2D
	speed = WALK_SPEED
	# Enable the general process callback
	set_physics_process(true)

	for strategy_path in MOVEMENT_STRATEGIES:
		var strategy = get_node(strategy_path)
		movement_strategies.append(strategy)

func _physics_process(delta: float) -> void:
	for strategy in movement_strategies:
		strategy.move(delta)
	
	for strategy in movement_strategies:
		strategy.set_rotation(direction.angle())
	
	var _new_velocity = move_and_slide(direction * speed)
