extends "res://scripts/WalkStrategy.gd"

onready var timer = get_node("Timer")

var rng = RandomNumberGenerator.new()

var moving = true

func _ready() -> void:
	._ready()
	
	rng.randomize()

func restart_timer() -> void:
	timer.start(rng.randf_range(1, 2))

func _on_Timer_timeout():
	moving = !moving
	if moving:
		enemy.speed = enemy.WALK_SPEED
		enemy.direction = Vector2.UP.rotated(rng.randf_range(0, 2*PI))
		timer.start(rng.randf_range(3, 5))
	else:
		enemy.speed = 0
		timer.start(rng.randf_range(1, 2))
