extends CanvasModulate

# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var dark = Color(40.0/255, 41.0/255, 40.0/255)
var light = Color(160.0/255, 160.0/255, 160.0/255)
onready var lighting = get_node("../LightingFader")
var is_dark = false

# Called when the node enters the scene tree for the first time.
func _ready():
	set_color(light)
	is_dark = false

func set_dark():
	is_dark = true
	set_color(dark)
	flicker_lights()

# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta: float):
#	pass

func _physics_process(delta: float):
	if is_dark and randi() % 500 == 0:
		flicker_lights()
		
func flicker_lights():
		lighting.play("illuminate")
